#version 130
#extension GL_EXT_gpu_shader3 : enable
#extension GL_EXT_gpu_shader4 : enable

//##COMMON_DEFINITIONS_SHADER##

uniform sampler2D textureColorCurve;
uniform sampler2D textureImage[3];

//uniform int useTexAlpha;
uniform int dissolveMode;

attribute vec2 colorCurveST;
attribute float filterAlpha;
attribute int paramBit;

out vec3 position;
out vec4 position4;
out vec3 normal;
out vec4 color;
out vec4 colorDiffuse;
out vec4 colorSpecular;
flat out int blend;
flat out int textureImageIndex; // valid 0-3 not use if 4;

void main(void)
{
    gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	
    vec4 baseColor = texture2D(textureColorCurve, colorCurveST);
    baseColor[3] *= filterAlpha;

    vec4 colorDiffuseBase = texture2D(textureColorCurve, colorCurveST+vec2(0, 0.3333));
    vec4 colorSpecularBase = texture2D(textureColorCurve, colorCurveST+vec2(0, 0.6666));
    
    float alphaOrg = baseColor.a;
    float alpha0 = alphaOrg;

    if (dissolveMode == 1)
	if (alphaOrg < 0.015)
	    alpha0 = 1;
    
    if (dissolveMode == 2)
	alpha0 = 1;
    
    color = vec4(baseColor.rgb * alpha0, alphaOrg);
    colorDiffuse = vec4(colorDiffuseBase.rgb * alpha0, alphaOrg);
    colorSpecular = vec4(colorSpecularBase.rgb * alpha0, alphaOrg);
    
    position = vec3(gl_ModelViewMatrix * gl_Vertex);
    position4 = gl_ModelViewMatrix * gl_Vertex;
    normal = gl_NormalMatrix * gl_Normal;

    gl_Position = ftransform();

    blend = paramBit % _PARAMBIT_BLEND_MOD;

    if ((paramBit / _PARAMBIT_USE_TEXTURE) % 2 == 0)
	textureImageIndex = 4;
    else
	textureImageIndex = (paramBit / _PARAMBIT_TEXTUREINDEX) % _PARAMBIT_TEXTUREINDEX_MOD;
}
