//#extension GL_EXT_gpu_shader4 : enable

uniform sampler1D textureCC;
uniform sampler3D texVol_1;
uniform sampler3D texVol_2;
uniform sampler3D texVol_3;
uniform sampler3D texVol_4;
uniform vec3 clipBoxMin;
uniform vec3 clipBoxMax;
uniform int forceDiscard0;
uniform int trim;
uniform float intervalGlobal;
uniform int subQuality;
uniform float scaleZdash;
uniform int blend;
uniform float nestSize[3];
uniform float nestRim[3];
uniform int nestType;
uniform float intervalFactor;

varying vec3 position;

//##FUNC_VOLUME_MASK_BEGIN##
bool GetMask(vec3 texCoord){
    return true;
}
//##FUNC_VOLUME_MASK_END##

//##FUNC_VOLUME_NEST##

//##FUNC_VOLUME_COORD_BEGIN##
//#define GTRIM 1
vec3 GetDeformCoord(vec3 vecOrg){
    return vecOrg;
}

#define GUSEMATRIX 0
mat3 GetDeformNormalMatrix(vec3 texCoord, vec3 deformedCoord){
    return mat3(1, 0, 0, 0, 1, 0, 0, 0, 1);
}
//##FUNC_VOLUME_COORD_END##

void main (void)
{
   
    gl_FragColor = vec4(0, 0, 0 ,0);

    //float factorIntegrate = 1.0/subQuality;

    vec3 viewVec = -normalize(position);
    float angleMod = sqrt (1 + (viewVec[0]*viewVec[0]+viewVec[1]*viewVec[1])/(viewVec[2]*viewVec[2]));
    vec3 viewVecGlobal = normalize(mat3(gl_ModelViewMatrixInverse) * viewVec) * intervalGlobal/subQuality * 3 * angleMod * intervalFactor;
    vec3 viewVecTexSpace = mat3(gl_TextureMatrix[0]) * viewVecGlobal/scaleZdash;
    vec3 srcPos = vec3(gl_TextureMatrixInverse[0] * gl_TexCoord[0]);

    int subCount = 0;
    for (int i = 0; i < subQuality; i++){

	vec3 tgtSubPos = srcPos + viewVecGlobal*i;

	if (any(lessThan(tgtSubPos, clipBoxMin))) continue;
	if (any(greaterThan(tgtSubPos, clipBoxMax))) continue;
			
	vec3 texCoord = vec3(gl_TexCoord[0] + viewVecTexSpace * i);
	vec3 deformedCoord = GetDeformCoord(texCoord);
	if (GetMask(deformedCoord) == false) continue;
	
	if (trim == 1){
	    if (any(lessThan   (deformedCoord, vec3(0, 0, 0)))) continue;
	    if (any(greaterThan(deformedCoord, vec3(1, 1, 1)))) continue;
	}
	
	float value = GetTexture3D_R(deformedCoord);
	//float value = texture3D(texVol_1, deformedCoord);
	
	if (forceDiscard0 == 1 && value == 0) continue;
	
	//vec4 texColor2 = texture1D(textureCC, value);
	vec4 color = texture1D(textureCC, value) * gl_Color;
	if (color.a == 0) continue;

	color.a *= angleMod; 

	gl_FragColor += color;
	subCount++;
    }

    if (gl_FragColor[3] == 0) discard;

    float factorCount = 1.0f/subCount;
    
    gl_FragColor.a *= factorCount;
    float alpha0 = gl_FragColor.a;
    
    gl_FragColor.r *= factorCount;
    gl_FragColor.g *= factorCount;
    gl_FragColor.b *= factorCount;
    //gl_FragColor.a *= factorIntegrate;

    switch(blend){
    case 0:
	gl_FragColor.rgb *= alpha0;
	//gl_FragColor.a = alpha;
	break;
    case 1:
	gl_FragColor.rgb *= alpha0;
	gl_FragColor.a = 0;
	break;
    case 2:
	gl_FragColor.rgb *= alpha0;
	gl_FragColor.a *= 0.5*alpha0;//(1 - alpha0);
	break;
    }
    
    return;
}
